WebServer (HSQLDB 2.4.1 API)
Date: 2018-05-20

org.hsqldb.server

## Class WebServer

- java.lang.Object
- - org.hsqldb.server.Server
  - - org.hsqldb.server.WebServer

- All Implemented Interfaces:
    org.hsqldb.lib.Notified, org.hsqldb.server.HsqlSocketRequestHandler

      public class WebServer
      extends Server

  The HSQLDB HTTP protocol network database server.

  WebServer has two distinct functions:

  The primary function is to allow client/server access to HSQLDB databases via the HTTP protocol. This protocol is less efficient than the HSQL protocol used by the Server class and should be used only in situations where sandboxes or firewalls between the client and the server do not allow the use of the HSQL protocol. One example is client/server access by an applet running in browsers on remote hosts and accessing the database engine on the HTTP server from which the applet originated. From version 1.7.2, HTTP database connections are persistent and support transactions. Similar to HSQL connections, they should be explicitly closed to free the server resources.

  The secondary function of WebServer is to act as a simple general purpose HTTP server. It is aimed to support the minimum requirements set out by the HTTP/1.0 standard. The HEAD and GET methods can be used to query and retrieve static files from the HTTP server.

  Both the database server and HTTP server functions of WebServer can be configured with the webserver.properties file. It contains entries for the database server similar to those for the HSQL protocol Server class. In addition, a list mapping different file endings to their mime types may be included in this file. (fredt@users)

  From the command line, the options are as follows:

       +-----------------+-------------+----------+------------------------------+
       |    OPTION       |    TYPE     | DEFAULT  |         DESCRIPTION          |
       +-----------------+-------------+----------+------------------------------|
       | --help          |             |          | prints this message          |
       | --address       | name|number | any      | server inet address          |
       | --port          | number      | 80       | port at which server listens |
       | --database.i    | [type]spec  | 0=test   | path of database i           |
       | --dbname.i      | alias       |          | url alias for database i     |
       | --silent        | true|false  | true     | false => display all queries |
       | --trace         | true|false  | false    | display JDBC trace messages  |
       | --no_system_exit| true|false  | false    | do not issue System.exit()   |
       +-----------------+-------------+----------+------------------------------+

  Example of the webserver.properties file:

       server.port=80
       server.database.0=test
       server.dbname.0=...
       ...
       server.database.n=...
       server.dbname.n=...
       server.silent=true

       .htm=text/html
       .html=text/html
       .txt=text/plain
       .gif=image/gif
       .class=application/octet-stream
       .jpg=image/jpeg
       .jgep=image/jpeg
       .zip=application/x-zip-compressed

  - For server.root, use '/' as the separator, even for DOS/Windows.
  - File extensions for mime types must be lowercase and start with '.'
  Since:
    1.7.2
  Author:
    Campbell Burnet (campbell-burnet@users dot sourceforge.net), Fred Toussi (fredt@users dot sourceforge.net)

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `WebServer()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getDefaultWebPage()` Retrieves the name of the web page served when no page is specified.
    `java.lang.String` | `getHelpString()` Retrieves a String object describing the command line and properties options for this Server.
    `java.lang.String` | `getProductName()` Retrieves this server's product name.
    `java.lang.String` | `getProtocol()` Retrieves a string representation of the network protocol this server offers, typically one of 'HTTP', HTTPS', 'HSQL' or 'HSQLS'.
    `java.lang.String` | `getWebRoot()` Retrieves the root context (directory) from which web content is served.
    `static void` | `main(java.lang.String[] args)` Starts a new WebServer.

    - ### Methods inherited from class org.hsqldb.server.Server

      `checkRunning, getAddress, getDatabaseName, getDatabasePath, getDatabaseType, getErrWriter, getLogWriter, getPort, getProductVersion, getServerError, getServerId, getServerThread, getState, getStateDescriptor, handleConnection, isNoSystemExit, isNotRunning, isRestartOnShutdown, isSilent, isTls, isTrace, notify, putPropertiesFromFile, putPropertiesFromFile, putPropertiesFromString, setAddress, setDaemon, setDatabaseName, setDatabasePath, setDefaultWebPage, setErrWriter, setLogWriter, setNoSystemExit, setPort, setProperties, setRestartOnShutdown, setSilent, setTls, setTrace, setWebRoot, shutdown, shutdownCatalogs, shutdownWithCatalogs, signalCloseAllServerConnections, start, stop`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### WebServer

          public WebServer()

  - ### Method Detail

    - #### main

          public static void main(java.lang.String[] args)

      Starts a new WebServer.
      Parameters:
        `args` - the "command line" parameters with which to start the WebServer. "-?" will cause the command line arguments help to be printed to the standard output

    - #### getDefaultWebPage

          public java.lang.String getDefaultWebPage()

      Retrieves the name of the web page served when no page is specified. This attribute is relevant only when server protocol is HTTP(S).
      Overrides:
        `getDefaultWebPage` in class `Server`
      Returns:
        the name of the web page served when no page is specified

    - #### getHelpString

          public java.lang.String getHelpString()

      Retrieves a String object describing the command line and properties options for this Server.
      Overrides:
        `getHelpString` in class `Server`
      Returns:
        the command line and properties options help for this Server

    - #### getProductName

          public java.lang.String getProductName()

      Retrieves this server's product name.

      Typically, this will be something like: "HSQLDB xxx server".

      Overrides:
        `getProductName` in class `Server`
      Returns:
        the product name of this server

    - #### getProtocol

          public java.lang.String getProtocol()

      Retrieves a string representation of the network protocol this server offers, typically one of 'HTTP', HTTPS', 'HSQL' or 'HSQLS'.
      Overrides:
        `getProtocol` in class `Server`
      Returns:
        string representation of this server's protocol

    - #### getWebRoot

          public java.lang.String getWebRoot()

      Retrieves the root context (directory) from which web content is served. This property is relevant only when the server protocol is HTTP(S). Although unlikely, it may be that in the future other contexts, such as jar urls may be supported, so that pages can be served from the contents of a jar or from the JVM class path.
      Overrides:
        `getWebRoot` in class `Server`
      Returns:
        the root context (directory) from which web content is served

Copyright © 2001 - 2018 HSQL Development Group.